--Declaration de la variable RedTransport
RedTransport = SPAWN:New( "Red_Transport" ):InitRandomizeRoute(1,0,20000)
:OnSpawnGroup(
    function( SpawnGroup )
	---------------creating the escort plane
		local RedEscort = SPAWN:New( "Red_Escort" )
		local RedE1 = RedEscort:Spawn()
		local PointVec3 = POINT_VEC3:New( 200, 0, -200 ) -- This is a Vec3 class.
		local FollowDCSTask = RedE1:TaskFollow( SpawnGroup, PointVec3:GetVec3() )
		RedE1:SetTask( FollowDCSTask, 1 )
	--------------------------------------------------------------------------------------	
		SpawnGroup:HandleEvent( EVENTS.Crash )
			function SpawnGroup:OnEventCrash( EventData )
				EventData.IniUnit:MessageToAll( "VIP Transport has declared a MAYDAY.Position has been transmitted to IRGC SAR units.", 15, "Alert!" )
				local redvipflag = USERFLAG:New( "300" )
				redvipflag:Set( 1 )
				if SpawnGroup:GetSize() == 1 then
				local winflag = USERFLAG:New("301")
				winflag:Set( 1 )
				end
			end
		SpawnGroup:HandleEvent( EVENTS.Land )
			function SpawnGroup:OnEventLand( EventData )
				EventData.IniUnit:MessageToAll( "The VIP Transport has landed in Bandar.", 15, "Alert!" )
				local redvipflag = USERFLAG:New( "300" )
				redvipflag:Set( 1 )
			end
    end)
-- swarming Air attack
local SwarmZone = { ZONE_POLYGON:New( "sw1", GROUP:FindByName( "sw1" ) )}

RedSwarm = SPAWN:New("Red_Swarm"):InitRandomizeZones( SwarmZone )
:OnSpawnGroup(	
	function( SpawnGroup )
		SpawnGroup:HandleEvent( EVENTS.Crash )
			function SpawnGroup:OnEventCrash( EventData )
				--self:E( "I just got hit and I am part of " .. EventData.TgtGroupName )
				EventData.IniUnit:MessageToAll( "Enemy plane has declared a MAYDAY.", 15, "Alert!" )
				local swarmflag = USERFLAG:New( "302" )
				swarmflag:Set( 1 )
				if SpawnGroup:GetSize() == 1 then
				local winflag2 = USERFLAG:New("303")
				winflag2:Set( 1 )
				end
			end
		SpawnGroup:HandleEvent( EVENTS.Land )
			function SpawnGroup:OnEventLand( EventData )
				EventData.IniUnit:MessageToAll( "Intruders reported back to their bases.", 15, "Alert!" )
				local redvipflag = USERFLAG:New( "303" )
				redvipflag:Set( 1 )
			end
    end)
-----------------------------------------------------------
-- patrouille naval harassing continuously
local NavalZone = { ZONE_POLYGON:New( "nz1", GROUP:FindByName( "nz1" ) )}
local rednavy = { "redn1", "redn2", "redn3" }
RedNavy = SPAWN:New( "Red_BAI_Patrol" ):InitRandomizeTemplate( rednavy ):InitRandomizeZones( NavalZone )
:OnSpawnGroup(
    function( SpawnGroup )
    SpawnGroup:PatrolZones(NavalZone,  28, "Vee" )
    SpawnGroup:HandleEvent( EVENTS.Dead )
		function SpawnGroup:OnEventDead( EventData )
		local NavyTask = USERFLAG:New( "304" )
		NavyTask:Set( 1 ) 
		end
    end)
-----------------------------------------------------------
---- AI controlling GCI and Cap for Red
-----------------------
RedDetectionSetGroup = SET_GROUP:New()
RedDetectionSetGroup:FilterPrefixes( "Red_Ewr" )
RedDetectionSetGroup:FilterStart()
RedDetection = DETECTION_AREAS:New( RedDetectionSetGroup, 30000 )
RedA2ADispatcher = AI_A2A_DISPATCHER:New( RedDetection )
RedA2ADispatcher:SetTacticalDisplay( false )
RedBorderZone = ZONE_POLYGON:New( "Red_Border", GROUP:FindByName( "Red_Border" ) )
RedA2ADispatcher:SetBorderZone( RedBorderZone )
RedA2ADispatcher:SetEngageRadius( 150000 )
RedA2ADispatcher:SetDisengageRadius( 200000 )
RedA2ADispatcher:SetGciRadius( 200000 )
RedA2ADispatcher:SetDefaultTakeoffInAir()
RedA2ADispatcher:SetDefaultLandingNearAirbase()
RedA2ADispatcher:SetSquadron( "Bandar", "Bandar Abbas Intl", { "Red_Sq_Type1", "Red_Sq_Type2", "Red_Sq_Type3" })
RedA2ADispatcher:SetSquadronOverhead( "Bandar", 1 )
RedA2ADispatcher:SetSquadronGrouping( "Bandar", 1 )
RedA2ADispatcher:SetSquadronTakeoffInAir( "Bandar" )
RedA2ADispatcher:SetSquadronLandingAtRunway( "Bandar" )
RedA2ADispatcher:SetSquadronGci( "Bandar", 800, 1200 )
-----------------------------------------------------------
CapZone1 = ZONE:New( "Red_Cap1" )
RedA2ADispatcher:SetSquadronCap( "Bandar", CapZone1, 3000, 6000, 500, 600, 800, 1000 )
RedA2ADispatcher:SetSquadronCapInterval( "Bandar", 1, 30, 60, 1 )
------------------------------------------------------------
RedA2ADispatcher:SetSquadron( "Lar", "Lar Airbase", { "Red_Sq_Type1", "Red_Sq_Type2", "Red_Sq_Type3" })
RedA2ADispatcher:SetSquadronOverhead( "Lar", 1 )
RedA2ADispatcher:SetSquadronGrouping( "Lar", 1 )
RedA2ADispatcher:SetSquadronTakeoffInAir( "Lar" )
RedA2ADispatcher:SetSquadronLandingAtRunway( "Lar" )
RedA2ADispatcher:SetSquadronGci( "Lar", 800, 1200 )
-------------------------------------------------------------------
DetectionSetGroup = SET_GROUP:New()
DetectionSetGroup:FilterPrefixes( "Blue_Ewr" )
DetectionSetGroup:FilterStart()
Detection = DETECTION_AREAS:New( DetectionSetGroup, 30000 )
A2ADispatcher = AI_A2A_DISPATCHER:New( Detection )
A2ADispatcher:SetTacticalDisplay( false )
BlueBorderZone = ZONE_POLYGON:New( "Blue_Border", GROUP:FindByName( "Blue_Border" ) )
A2ADispatcher:SetBorderZone( BlueBorderZone )
A2ADispatcher:SetEngageRadius( 150000 )
A2ADispatcher:SetDisengageRadius(200000 )
A2ADispatcher:SetGciRadius( 200000 )
A2ADispatcher:SetDefaultTakeoffInAir()
A2ADispatcher:SetDefaultLandingNearAirbase()
--------------------------------------------------------------------------------
A2ADispatcher:SetSquadron( "CarrierSq", "Carrier", { "Blue_Sq_FA18C" } )
A2ADispatcher:SetSquadronOverhead( "CarrierSq", .75 )
A2ADispatcher:SetSquadronGrouping( "CarrierSq", 1 )
A2ADispatcher:SetSquadronTakeoffFromParkingCold( "CarrierSq" )
A2ADispatcher:SetSquadronLandingAtRunway( "CarrierSq" )
A2ADispatcher:SetSquadronGci( "CarrierSq", 900, 1200 )
-- Blue_Group = GROUP:FindByName("Blue_Ewr_Fleet")
-- ZoneCarrier = ZONE_GROUP:New("BlueZoneCarrier", Blue_Group, 50000)
-- A2ADispatcher:SetSquadronCap( "CarrierSq", ZoneCarrier, 4000, 8000, 600, 800, 800, 1200, "BARO" )
-- A2ADispatcher:SetSquadronCapInterval( "CarrierSq", 1, 30, 120, 1 )
---------------------------------------------------------------------------------
---------------------------------------------------
BlueAwacsMinhad = SPAWN:New( "Blue_Ewr_Awacs_Minhad" ):InitLimit( 1, 0 ):InitRepeatOnLanding():SpawnScheduled( 900, 0)
RedAwacsBandar = SPAWN:New( "Red_Ewr_Awacs_Bandar" ):InitLimit( 1, 0 ):InitRepeatOnLanding():SpawnScheduled( 900, 0)
BlueTankerMinhad = SPAWN:New( "Blue_Tanker_Minhad" ):InitLimit( 1, 0 ):InitRepeatOnLanding():SpawnScheduled( 900, 0)
BRadarMinhad = SPAWN:New( "Blue_Ewr_Patriot_Minhad" ):InitLimit( 25, 0 ):SpawnScheduled( 3600, 0.1)
BRadarHawk = SPAWN:New( "Blue_Ewr_Hawk" ):InitLimit( 10, 0 ):SpawnScheduled( 3600, 0.2)
RRadarBandar = SPAWN:New( "Red_Ewr_S300_Bandar" ):InitLimit( 20, 0 ):SpawnScheduled( 3600, 0)
RRadarLar = SPAWN:New( "Red_Ewr_S300_Lar" ):InitLimit( 20, 0 ):SpawnScheduled( 3600, 0.2)
------------------------------------------------------------------------------------
-----------------------------------------------------------
--- every 10 seconds it will check the status of the previous mission and spawn the next one
--- and back at the start
local testflag3  = USERFLAG:New("304")
testflag3:Set(1)
local TestScheduler = SCHEDULER:New( nil, 
	function()
		----mission logic
		local testflag  = USERFLAG:New("300")
		local testcond = testflag:Get()
		if testcond == 1 then
		-- si le flag 300 alors vip est dead ouu atterit
		testflag:Set(0)
		rs = RedSwarm:Spawn()
		MESSAGE:New( "HQ: Multiple air contacts! Tune in 251Mhz Awacs!",  25, "Alert!" ):ToBlue()
		end
		local testflag2  = USERFLAG:New("303")
		local testcond2 = testflag2:Get()
		if testcond2 == 1 then
		-- si le flag 303 alors swarm est dead ou atterit
		testflag2:Set(0)
		rn = RedNavy:Spawn()
		MESSAGE:New( "HQ: Hostile vessel moving along the east coast",  25, "Alert!" ):ToBlue()
		end
		local testflag3  = USERFLAG:New("304")
		local testcond3 = testflag3:Get()
		if testcond3 == 1 then
		-- si le flag 300 alors navy is sunk
		testflag3:Set(0)
		rt = RedTransport:Spawn()
		MESSAGE:New( "HQ: An unknown transport is on radar! Check in with Awacs",  25, "Alert!" ):ToBlue()
		end

	end, {}, 10, 10 --10 secondes
  )